if GS_RAILS_SKINS == nil 
	rawset(_G,"GS_RAILS_SKINS",{}) 
end

GS_RAILS_SKINS["shadow"] = {}

local SKIN = GS_RAILS_SKINS["shadow"]

SKIN["S_SKIN"] = {
	JUMP = true,
	JUMPBOOST = true,
	AIRDRAG = 0,
	SIDEHOP = 26,
	SIDEHOPARC = 25,
	SIDEFLIP = SPR2_SPNG,
	SIDEHOPTIME = 13,
	EMERGENCYDROP = false,
	CROUCH = true,
	CROUCHBUTTON = BT_TOSSFLAG,
	AUTOBALANCE = false,
	SLOPEPHYSICS = true,
	MUSTBALANCE = false,
	SLOPEMULT = 10,
	LAUNCHPOWER = 0,
	STARTMODIFIER = 0,
	STARTSPEEDCONDITION = 0,
	HEROESTWIST = 0,
	TWISTBUTTON = 0,
	ACCELSPEED = 0,
	ACCELCAP = 0,
	AUTODASHMODE = 72,
	MINSPEED = 0,
	MAXSPEED = 0,
	FORCESPRITE = nil,
	FORCEHANGSPRITE = nil,
	NOWINDLINES = true,
	NOSIDEHOPGFX = 0,
	NOFUNALLOWED = true
}

SKIN["PreAttach"] = function(player, s, GS, rail, METHOD, SLOPEFLING)
	if player.shadowboost
	or player.shadowrailboost
	or player.spintics > 1
		player.shadowrailboost = true
	end
	player.pflags = $ & ~PF_THOKKED
	player.shadowboostair = false
end

SKIN["GrindThinker"] = function(player, mo, GS, rail)
	if mo and mo.valid
	and mo.skin == "shadow"
		local dir = GS_RAILS.GrindFlip(mo, GS.myrail, true)
		if player.spintics == 1
			S_StartSound(player.mo, sfx_bkpoof)
			local shockwave = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PARTICLE)
			shockwave.state = S_SHADOW_BOOSTSHOCKWAVE
			shockwave.angle = player.mo.angle
			shockwave.color = SKINCOLOR_WHITE
			shockwave.colorized = true
			player.shadowboosts = shockwave
			player.shadowrailboost = true
			if abs(GS.railspeed) < 50*FRACUNIT
				GS.railspeed = dir*(50*FRACUNIT)
			end
			if consoleplayer == player
				P_StartQuake(45*FRACUNIT, TICRATE/2)
			end
		end
		if player.shadowrailboost
			if P_PlayerInPain(player)
				player.shadowrailboost = false
				S_StopSoundByID(player.mo, sfx_s3kcfl)
				player.camerascale = FRACUNIT
				return
			end
			GS.cantcrouch = 2
			GS.crouchgrind = false
			if player.shadowboosta ~= nil
			and player.shadowboosta and player.shadowboosta.valid
				P_RemoveMobj(player.shadowboosta)
			end
			local dist = max(player.speed / (4*FRACUNIT), 1)
			player.shadowboosta = P_SpawnMobjFromMobj(player.mo, player.mo.momx/dist, player.mo.momy/dist, player.mo.momz/dist, MT_PARTICLE)
			player.shadowboosta.state = S_SHADOW_BOOSTAURA
			player.shadowboosta.angle = player.drawangle
			if player.shadow_skatecolor ~= nil
				player.shadowboosta.color = player.shadow_skatecolor
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if player.speed < 90*FRACUNIT
					GS.railspeed = $ + (dir*(FRACUNIT/5))
				end
			else
				if player.speed < 90*FRACUNIT
					GS.railspeed = $ + (dir*(FRACUNIT/10))
				end
			end
			if not S_SoundPlaying(player.mo, sfx_s3kcfl)
				S_StartSound(player.mo, sfx_s3kcfl)
			end
			if player.speed < 50*FRACUNIT
			and player.spintics > 5
				GS.railspeed = dir*(50*FRACUNIT)
			end
			if player.spintics <= 0
				player.shadowrailboost = false
				S_StopSoundByID(player.mo, sfx_s3kcfl)
				if player.shadowboosta ~= nil
					P_RemoveMobj(player.shadowboosta)
				end
			end
		end
	end
end

SKIN["PreExit"] = function(player, s, GS, rail, METHOD)
	if player.shadowrailboost
	and not (player.mo.eflags & MFE_SPRUNG)
		player.shadowboost = true
		player.shadowrailboost = false
	end
	player.pflags = $ & ~PF_THOKKED
	player.shadowboostair = false
end