local kirbvalid = 0

rawset(_G, "K_PuffinKirb", function(checkflags, destroy, late, player)
	if (checkflags)
		if (player.kvars.ablstate)
		or (player.kvars.ablvar1)
			return AF_NODROP
		end
		return 0
	end
	if (destroy)
		return
	end
	if (late)
		return
	end
	if player.spintics
	and not (player.kvars.ablvar1)
	and not (player.kvars.floating)
	and not (player.pflags & PF_SLIDING)
	and not (player.powers[pw_carry])
	and not (player.exiting)
	and not (player.pflags & PF_STASIS)
	and not (player.powers[pw_nocontrol])
	and not (player.kvars.industdevil)
	and not P_PlayerInPain(player)
		if not player.kvars.ablstate
			player.kvars.ablvar1 = $ + 1
			player.kvars.ablvar2 = player.mo.color
			S_StartSound(player.mo, sfx_kbchge)
			if (player.pflags & PF_SPINNING)
				player.pflags = $ & ~PF_SPINNING
			end
		end
	end
	if player.kvars.ablvar1
		if P_PlayerInPain(player)
		or player.powers[pw_carry]
			player.kvars.ablvar1 = 0
			player.mo.colorized = false
			player.mo.color = player.kvars.ablvar2
			return
		end
		player.kvars.ablvar1 = $ + 1
		local ghost = SpawnGhost(player)
		ghost.fuse = 3
		ghost.blendmode = AST_ADD
		ghost.frame = $ & ~(FF_TRANSMASK) | FF_TRANS50
		P_SetOrigin(ghost, player.mo.x, player.mo.y, player.mo.z)
		ghost.momx = 3*player.mo.momx/4
		ghost.momy = 3*player.mo.momy/4
		ghost.momz = 3*player.mo.momz/4
		ghost.dispoffset = 4
		local ghost2 = SpawnGhost(player)
		ghost2.fuse = 3
		ghost2.scale = $ + ($/5)
		ghost2.frame = $ & ~(FF_TRANSMASK) | FF_TRANS80
		P_SetOrigin(ghost2, player.mo.x, player.mo.y, player.mo.z - (player.mo.height/10))
		ghost2.momx = 3*player.mo.momx/4
		ghost2.momy = 3*player.mo.momy/4
		ghost2.momz = 3*player.mo.momz/4
		ghost2.dispoffset = 5
		if player.kvars.ablvar1%2 == 1
			player.mo.colorized = true
			if player.kvars.ablvar1 < TICRATE
				player.mo.color = SKINCOLOR_ROSY
			elseif player.kvars.ablvar1 > TICRATE
			and player.kvars.ablvar1 < 2*TICRATE
				player.mo.color = SKINCOLOR_NEON
			else
				player.mo.color = SKINCOLOR_GALAXY
			end
		elseif player.kvars.ablvar1%2 ~= 1
			player.mo.colorized = false
			player.mo.color = player.kvars.ablvar2
		end
		if not player.spintics
		or player.kvars.ablvar1 >= 3*TICRATE
			S_StopSoundByID(player.mo, sfx_kbchge)
			player.mo.colorized = false
			player.mo.color = player.kvars.ablvar2
			local x,y = cos(player.drawangle),sin(player.drawangle)
			S_StartSound(player.mo, sfx_spitl)
			local x,y = cos(player.drawangle),sin(player.drawangle)
			local momz = (sin(player.aiming)*90)
			local laser = P_SpawnMobjFromMobj(
				player.mo,
				cos(player.mo.angle-ANGLE_22h)*20 + P_RandomRange(-10, 10),
				sin(player.mo.angle-ANGLE_22h)*20 + P_RandomRange(-10, 10),
				player.mo.height/2 + P_RandomRange(-10, 10),
				MT_KIRBYSPITSTAR
			)
			laser.kirbymulti = true
			laser.target = player.mo
			local angle = player.mo.angle 
			angle = $ + 0
			local vangle = player.aiming
			local speed = player.speed + 60*FRACUNIT
			local horizpush = FixedMul(cos(vangle), speed)
			laser.momx = FixedMul(cos(angle), horizpush)
			laser.momy = FixedMul(sin(angle), horizpush)
			laser.momz = FixedMul(sin(vangle), speed)
			laser.angle = angle
			laser.target = player.mo
			if player.kvars.ablvar1 >= TICRATE
				laser.scale = $*(player.kvars.ablvar1/TICRATE)
				if player.kvars.ablvar1 >= 3*TICRATE
					laser.dothefunny = true
				end
			end
			player.mo.state = S_KIRBY_SPIT
			player.kvars.ablvar1 = 0
		end
	end
end)

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_StartCrumble(sec, fof, false, mo.target.player, fof.alpha, true) -- Crumble
  end
end

addHook("MobjLineCollide", function(mobj, line)
	if mobj and mobj.valid
	and line and line.valid
	and mobj.dothefunny
		for _, sec in ipairs({line.frontsector, line.backsector})
			CheckAndCrumble(mobj, sec)
		end
	end
end, MT_KIRBYSPITSTAR)

addHook("MobjThinker", function(laser)
	if laser and laser.valid
	and laser.dothefunny
		CheckAndCrumble(laser, laser.subsector.sector)
	end
end, MT_KIRBYSPITSTAR)

addHook("ThinkFrame", function()
	if skins["kirby"]
		kirbvalid = $ + 1
	end
	if kirbvalid == 1
		local addednum = K_AddAbility(K_PuffinKirb, false, "PUFF")
		kirbyabilitytable["tails"] = addednum
	end
end)