// Global

addHook("PlayerThink", function(player)
	if not P_IsPlayerManiafied(player) return end
	if player.bubblebounce == nil
		player.bubblebounce = false
	end
	if player.attracthoming == nil
		player.attracthoming = 0
	end
	if player.elementaldive == nil
		player.elementaldive = false
	end
	if player.powers[pw_shield]
	and (player.cmd.buttons & BT_CUSTOM2)
	and not P_IsPlayerOnGround(player)
	and not (player.pflags & PF_THOKKED)
		player.pflags = $|PF_THOKKED
		if not player.powers[pw_carry]
		and ((player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND)
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			player.mo.state = S_PLAY_FALL
			player.pflags = $ & ~PF_JUMPED
			S_StartSound(player.mo, sfx_wirlsg)
		end
		if (player.pflags & PF_JUMPED)
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON)
				P_BlackOw(player)
			end
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN)
				P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
				player.mo.state = S_PLAY_JUMP
				S_StartSound(player.mo, sfx_s3k41)
			end
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP)
				P_SetObjectMomZ(player.mo, -10*FRACUNIT, false)
				player.bubblebounce = true
				S_StartSound(player.mo, sfx_s3k3f)
			end
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT)
				if P_LookForEnemies(player, false, false)
					P_LookForEnemies(player, false, false)
					S_StartSound(player.mo, sfx_s3k40)
					player.attracthoming = 35
				else
					player.pflags = $ & ~PF_THOKKED
				end
			end
			if (player.powers[pw_shield] & SH_FORCE)
				if (player.powers[pw_shield] & SH_FORCEHP)
					S_StartSound(player.mo, sfx_forcsg)
				else
					S_StartSound(player.mo, sfx_frcssg)
				end
				P_InstaThrust(player.mo, 0, 0)
				P_SetObjectMomZ(player.mo, 0, false)
			end
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA)
				P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
				player.mo.momz = $/2
				S_StartSound(player.mo, sfx_s3k3e)
			end
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL)
				P_SetObjectMomZ(player.mo, -20*FRACUNIT, false)
				P_InstaThrust(player.mo, 0, 0)
				S_StartSound(player.mo, sfx_elemsg)
				player.elementaldive = true
			end
		end
	end
	if player.elementaldive
		if P_PlayerInPain(player)
		or player.powers[pw_carry]
			player.elementaldive = false
			return
		end
		P_SetObjectMomZ(player.mo, -20*FRACUNIT, false)
		P_InstaThrust(player.mo, 0, 0)
		if P_IsPlayerOnGround(player)
			if not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
			else
				P_SetObjectMomZ(player.mo, (5*FRACUNIT)/2, false)
			end
			P_ElementalFire(player, true)
			player.elementaldive = false
		end
	end
	if player.attracthoming
		if P_PlayerInPain(player)
		or player.powers[pw_carry]
			player.attracthoming = false
			return
		end
		player.attracthoming = $ - 1
		if player.mo.target and player.mo.target.valid
			P_HomingAttack(player.mo, player.mo.target)
		else
			player.attracthoming = 0
		end
	end
	if player.bubblebounce
		if P_PlayerInPain(player)
		or player.powers[pw_carry]
			player.bubblebounce = false
			return
		end
		P_SetObjectMomZ(player.mo, -10*FRACUNIT, false)
		if P_IsPlayerOnGround(player)
			P_DoBubbleBounce(player)
			player.bubblebounce = false
		end
	end
end)

// Sonic

addHook("JumpSpinSpecial", function(player)
	if player.mo.skin ~= "sonic" return end
	return true
end)

addHook("SpinSpecial", function(player) //Spin check
	if player.mo.skin ~= "sonic" return end //Skin check
	if player.candropdash ~= true return end //Dropdash capability check
	if player.dpspin == false return end //Is the dropdash not on spin?
	if (player.cmd.buttons & BT_USE) //Is player holding spin
	and not P_IsPlayerOnGround(player) //Is player on ground?
	and not player.dropdash //Is the player dropdashing?
	and not (player.pflags & PF_THOKKED) //Has the player used their ability?
	and not player.jumpdash
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
		player.dropdash = true //Set dropdash to true
		if player.dodpanim //If the dropdash animation is on...
			player.dpanim = 16 //Start it
		else //if it's off...
			player.dpanim = 0 //Dont start it
		end
		S_StartSound(player.mo, sfx_dpds) //Start dropdash sfx
		if player.dpanim //If dropdash anim on...
			player.mo.state = S_PLAY_SPRING //Set the state to spring
		else // If it's off...
			player.mo.state = S_PLAY_ROLL //Dont start it
		end
		return true //Make this the player's default ability if all checks return true
	end
end) //End the hook

addHook("PostThinkFrame", function() //We gonna be needing this to check for stuff after everything's happened
	for player in players.iterate() //Go through all players
		if player.mo and player.mo.valid
			if player.mo.skin ~= "sonic" continue end //Skin check //Imma leave you alone now
			if player.candropdash == nil
				player.candropdash = true
			end
			if player.dpspin == nil
				player.dpspin = true
			end
			if player.dodpanim == nil
				player.dodpanim = false
			end
			if player.insta == nil
				player.insta = false
			end
			if player.instas == nil
				player.instas = false
			end
			if player.dpsquake == nil
				player.dpsquake = true
			end
			if player.dropdash == nil
				player.dropdash = false
			end
			if player.dpanim == nil
				player.dpanim = 0
			end
			if player.dpanim > 0
				player.dpanim = $ - 1
			end
			if player.swj == nil
				player.swj = 0
			end
			if player.swj > 0
				player.swj = $ - 1
				local dropDashFrames = {A, D, F}
				local iWantThisFrame = dropDashFrames[(leveltime % #dropDashFrames) + 1]
				player.mo.sprite2 = SPR2_ROLL
				player.mo.frame = $ & (~FF_FRAMEMASK) | iWantThisFrame
			end
			// Dropdash
			if P_IsPlayerOnGround(player)
			and player.dpanim > 0
				player.dpanim = 0
			end
			if player.dropdash
				if P_PlayerInPain(player)
				or player.powers[pw_carry]
				or (player.mo.eflags & MFE_SPRUNG)
					player.dropdash = false
					return
				end
				if player.dpanim
					if player.dpanim > 8
						player.mo.state = S_PLAY_SPRING
					elseif player.dpanim > 4 and player.dpanim < 8
						player.mo.state = S_PLAY_FALL
					elseif player.dpanim <= 4
						local dropDashFrames = {A, D, F}
						local iWantThisFrame = dropDashFrames[(leveltime % #dropDashFrames) + 1]
						player.mo.sprite2 = SPR2_ROLL
						player.mo.frame = $ & (~FF_FRAMEMASK) | iWantThisFrame
					end
				else
					local dropDashFrames = {A, B, D, E}
					local iWantThisFrame = dropDashFrames[(leveltime % #dropDashFrames) + 1]
					player.mo.sprite2 = SPR2_ROLL
					player.mo.frame = $ & (~FF_FRAMEMASK) | iWantThisFrame
				end
				local ghost = SpawnGhost(player)
				ghost.fuse = 3
				ghost.blendmode = AST_ADD
				ghost.frame = $ & ~(FF_TRANSMASK) | FF_TRANS50
				P_SetOrigin(ghost, player.mo.x, player.mo.y, player.mo.z)
				ghost.momx = 3*player.mo.momx/4
				ghost.momy = 3*player.mo.momy/4
				ghost.momz = 3*player.mo.momz/4
				ghost.dispoffset = 4
				local ghost2 = SpawnGhost(player)
				ghost2.fuse = 3
				ghost2.scale = $ + ($/5)
				ghost2.frame = $ & ~(FF_TRANSMASK) | FF_TRANS80
				P_SetOrigin(ghost2, player.mo.x, player.mo.y, player.mo.z - (player.mo.height/10))
				ghost2.momx = 3*player.mo.momx/4
				ghost2.momy = 3*player.mo.momy/4
				ghost2.momz = 3*player.mo.momz/4
				ghost2.dispoffset = 5
			end
			if (P_PlayerInPain(player)
			or P_IsPlayerOnGround(player)
			or player.playerstate == PST_DEAD
			or (player.mo.eflags & MFE_SPRUNG)
			or not (player.dpspin == false and (player.cmd.buttons & BT_JUMP) or player.dpspin == true and (player.cmd.buttons & BT_USE)))
			and player.dropdash
				player.dropdash = false
				player.dpanim = 0
				if P_IsPlayerOnGround(player)
				and not P_PlayerInPain(player)
				and player.playerstate ~= PST_DEAD
					if not player.powers[pw_sneakers]
						if not player.powers[pw_underwater]
							if not player.powers[pw_super]
								P_InstaThrust(player.mo, player.drawangle, ((skins[player.mo.skin].normalspeed + 15*FRACUNIT) + (player.speed/2)))
							else
								P_InstaThrust(player.mo, player.drawangle, ((skins[player.mo.skin].normalspeed + 25*FRACUNIT) + (player.speed/2)))
							end
						else
							if not player.powers[pw_super]
								P_InstaThrust(player.mo, player.drawangle, (((skins[player.mo.skin].normalspeed/2) + 5*FRACUNIT) + (player.speed/2)))
							else
								P_InstaThrust(player.mo, player.drawangle, (((skins[player.mo.skin].normalspeed/2) + 15*FRACUNIT) + (player.speed/2)))
							end
						end
					else
						if not player.powers[pw_underwater]
							P_InstaThrust(player.mo, player.drawangle, ((skins[player.mo.skin].normalspeed + 25*FRACUNIT) + (player.speed/2)))
						else
							P_InstaThrust(player.mo, player.drawangle, (((skins[player.mo.skin].normalspeed/2) + 15*FRACUNIT) + (player.speed/2)))
						end
					end
					if not player.powers[pw_super]
						S_StartSound(player.mo, sfx_zoom)
					else
						S_StartSound(player.mo, sfx_spdd)
					end
					player.pflags = $|PF_SPINNING
					coollookindust(player)
					if player.dpsquake
					and player.powers[pw_super]
						if consoleplayer == player
							P_StartQuake(45*FRACUNIT, TICRATE/2)
						end
					end
				end
			end
			// Jump Dash
			if player.jumpdash == nil
				player.jumpdash = 0
			end
			if player.jumpdashc == nil
				player.jumpdashc = 0
			end
			if player.jumpdashs == nil
				player.jumpdashs = 0
			end
			if player.jumpdashz == nil
				player.jumpdashz = 0
			end
			if player.jumpdasha == nil
				player.jumpdasha = 0
			end
			if P_IsPlayerOnGround(player)
			and player.speed >= 50*FRACUNIT
			and player.cmd.forwardmove < 0
			and (player.pflags & PF_SPINNING)
			and (player.powers[pw_super]
			or player.powers[pw_sneakers])
				player.jumpdashc = 3*TICRATE
				player.jumpdashs = player.speed
				player.jumpdasha = player.mo.angle
				player.jumpdashz = 0
				S_StartSound(player.mo, sfx_skid)
			end
			if player.jumpdashc
				if P_PlayerInPain(player)
				or player.powers[pw_carry]
					player.jumpdashc = 0
					player.mo.spriteyscale = FRACUNIT
					continue
				end
				player.jumpdashc = $ - 1
				player.jumpdasha = player.mo.angle
				player.drawangle = player.jumpdasha
				player.mo.state = S_PLAY_ROLL
				player.mo.momx = 0
				player.mo.momy = 0
				if player.mo.spriteyscale > FRACUNIT/2
					player.mo.spriteyscale = $ - FRACUNIT/35
				end
				if player.jumpdashz > player.jumpdashs/2
					player.jumpdashz = player.jumpdashs/2
				end
				if player.jumpdashz < 0
					player.jumpdashz = 0
				end
				if player.jumpdashc < 3*TICRATE - 10
					if player.cmd.forwardmove > 0
						player.jumpdashz = $ + FRACUNIT
					elseif player.cmd.forwardmove < 0
						player.jumpdashz = $ - FRACUNIT
					end
				end
				local x,y = cos(player.jumpdasha), sin(player.jumpdasha)
				for zheight = 1, 5
					local orb = P_SpawnMobjFromMobj(player.mo, ((player.jumpdashs/FRACUNIT)*zheight)*x, ((player.jumpdashs/FRACUNIT)*zheight)*y, player.jumpdashz*zheight, MT_THOK)
					orb.scale = ($/2)/zheight
					orb.color = player.mo.color
					orb.tics = 1
				end
				if player.jumpdashc <= 0
				or (player.cmd.buttons & BT_JUMP)
					S_StopSoundByID(player.mo, sfx_jump)
					player.jumping = false
					player.jumpdashc = 0
					player.jumpdash = 35
					player.mo.spriteyscale = FRACUNIT
				end
			end
			if player.jumpdash
				if P_PlayerInPain(player)
				or player.powers[pw_carry]
					player.jumpdash = 0
					continue
				end
				player.jumpdash = $ - 1
				player.mo.state = S_PLAY_SPRING
				player.drawangle = player.jumpdasha
				P_InstaThrust(player.mo, player.jumpdasha, player.jumpdashs)
				P_SetObjectMomZ(player.mo, player.jumpdashz, false)
				SpawnGhost(player)
				if player.powers[pw_pushing]
				or player.jumpdash <= 0
				or player.spintics == 1
					player.jumpdash = 0
					player.mo.state = S_PLAY_JUMP
					player.mo.momz = $/3
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "sonic" return end
	if player.candropdash ~= true return end
	if player.dpspin == true
		return true
	end
end)

addHook("MobjMoveBlocked", function(mobj, mo, line)
	if mo or mo and mo.valid return end
	if mobj.skin ~= "sonic" return end
	if mobj and mobj.valid
	and mobj.player
	and mobj.player.swj <= 0
	and (mobj.player.cmd.buttons & BT_JUMP)
	and (mobj.player.cmd.buttons & BT_USE)
	and line and line.valid
		local player = mobj.player
		player.drawangle = GetWallAngle(player.mo, line) + ANGLE_180
		player.mo.state = S_PLAY_JUMP
		player.swj = 15
		P_Thrust(player.mo, GetWallAngle(player.mo, line) + ANGLE_180, player.speed > 20*FRACUNIT and player.speed or 20*FRACUNIT)
		player.jumping = false
		if not player.powers[pw_underwater]
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
		else
			P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
		end
		player.jumping = false
		S_StartSound(player.mo, sfx_jump)
		player.pflags = $ & ~PF_THOKKED
		player.pflags = $|PF_JUMPED
		player.dropdash = false
	end
end)

// Tails

addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "tails" return end
	if (player.cmd.buttons & BT_JUMP)
	and not P_IsObjectOnGround(player.mo)
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
	and not player.fly
	and not player.fly2
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
		player.fly = 6*TICRATE
		player.flyheight = 0*FRACUNIT
		P_InstaThrust(player.mo, player.mo.angle, (50 - abs(player.flyheight/FRACUNIT))*FRACUNIT)
		P_SetObjectMomZ(player.mo, player.flyheight, false)
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.powers[pw_carry] == CR_PLAYER
	or player.mo.state == S_PLAY_TAILS_TIRED
	or player.fly2u)
		coolspeedwindlines(player)
		if leveltime%10 == 0
			coollookindust(player)
		end
		SpawnGhost(player)
	end
	if player.mo and player.mo.valid
		if player.mo.skin ~= "tails"
		or not player.fly
		and not player.fly2
			player.fly = 0
			player.fly2 = 0
			player.pflags = $ & ~PF_CANCARRY
		end
	end
	if player.mo and player.mo.valid
		if player.mo.skin ~= "tails" return end
		if player.fly == nil
			player.fly = 0*TICRATE
		end
		if player.flyheight == nil
			player.flyheight = 0*FRACUNIT
		end
		if player.flyuse == nil
			player.flyuse = 0
		end
		if player.fly2 == nil
			player.fly2 = 0
		end
		if player.fly2u == nil
			player.fly2u = false
		end
		if player.fly2t1 == nil
			player.fly2t1 = false
		end
		if player.tiredtics == nil
			player.tiredtics = 0
		end
		if player.mo.state == S_PLAY_FLY
		and not player.fly2
		and player.fly1
		and player.mo.momz <= 0
			player.fly1 = 0
			player.fly2 = 5*TICRATE
			player.fly2t1 = true
		end
		if player.fly > 0
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.fly = 0
				player.pflags = $ & ~PF_CANCARRY
				return
			end
			player.drawangle = player.mo.angle
			player.pflags = $|PF_CANCARRY|PF_JUMPED
			coolspeedwindlines(player)
			if leveltime%10 == 0
				coollookindust(player)
			end
			SpawnGhost(player)
			if not (player.mo.eflags & MFE_UNDERWATER)
				player.fly = $ - 1
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if abs(player.flyheight) <= 25*FRACUNIT
					if player.mo.state ~= S_PLAY_RUN
						player.mo.state = S_PLAY_RUN
					end
				else
					if player.mo.state ~= S_PLAY_FLY
						player.mo.state = S_PLAY_FLY
					end
				end
			else
				if player.mo.state ~= S_PLAY_SWIM
					player.mo.state = S_PLAY_SWIM
				end
			end
			if (player.cmd.buttons & BT_JUMP)
				player.flyheight = $ + FRACUNIT
			elseif (player.cmd.buttons & BT_USE)
				player.flyheight = $ - FRACUNIT
			end
			P_InstaThrust(player.mo, player.mo.angle, not (player.mo.eflags & MFE_UNDERWATER) and (50 - abs(player.flyheight/FRACUNIT))*FRACUNIT or (player.mo.eflags & MFE_UNDERWATER) and (25 - abs(player.flyheight/FRACUNIT))*FRACUNIT)
			P_SetObjectMomZ(player.mo, player.flyheight, false)
			S_StopSoundByID(player.mo, sfx_pudpud)
			if not S_SoundPlaying(player.mo, sfx_putput)
			and not (player.mo.eflags & MFE_UNDERWATER)
				S_StartSound(player.mo, sfx_putput)
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if player.flyheight > 50*FRACUNIT
					player.flyheight = 50*FRACUNIT
				elseif player.flyheight < -50*FRACUNIT
					player.flyheight = -50*FRACUNIT
				end
			else
				if player.flyheight > 30*FRACUNIT
					player.flyheight = 30*FRACUNIT
				elseif player.flyheight < -30*FRACUNIT
					player.flyheight = -30*FRACUNIT
				end
			end
			if player.powers[pw_pushing]
				player.fly = 0
				player.flyuse = $ + 1
				P_DoPlayerPain(player)
				player.powers[pw_flashing] = 0
				player.pflags = $ & ~PF_CANCARRY
				return
			end
			if player.fly == 0
				player.mo.state = S_PLAY_TAILS_TIRED
				S_StopSoundByID(player.mo, sfx_putput)
				S_StartSound(player.mo, sfx_pudpud)
				player.pflags = $ & ~PF_CANCARRY
			end
		end
		if player.mo.state == S_PLAY_TAILS_TIRED
			P_SetObjectMomZ(player.mo, FRACUNIT/3, true)
			if not S_SoundPlaying(player.mo, sfx_pudpud)
			and not (player.mo.eflags & MFE_UNDERWATER)
				S_StartSound(player.mo, sfx_pudpud)
			end
		end
		if player.spintics == 1
		and not P_IsPlayerOnGround(player)
		and not player.powers[pw_carry]
		and not player.fly2u
		and not player.fly2
		and not player.fly
		and not P_PlayerInPain(player)
			player.fly2 = 2*TICRATE
		end
		if player.fly2
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
			or P_IsPlayerOnGround(player)
				player.fly2 = 0
				return
			end
			if (not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz <= 0
			or (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz >= 0)
			and not (player.mo.eflags & MFE_SPRUNG)
				P_SetObjectMomZ(player.mo, 0, false)
				player.fly2 = $ - 1
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if player.mo.state ~= S_PLAY_FLY
					player.mo.state = S_PLAY_FLY
				end
			else
				if player.mo.state ~= S_PLAY_SWIM
					player.mo.state = S_PLAY_SWIM
				end
			end
			player.pflags = $|PF_CANCARRY|PF_JUMPED
			coolspeedwindlines(player)
			if leveltime%10 == 0
				coollookindust(player)
			end
			SpawnGhost(player)
			S_StopSoundByID(player.mo, sfx_pudpud)
			if not S_SoundPlaying(player.mo, sfx_putput)
			and not (player.mo.eflags & MFE_UNDERWATER)
				S_StartSound(player.mo, sfx_putput)
			end
			if player.jumptics > 0
			and player.jumptics < 3
			and not player.fly1
				player.fly2 = 0
				if not player.powers[pw_super]
					player.fly2u = true
				end
				player.fly = 6*TICRATE
				player.flyheight = 0*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, (50 - abs(player.flyheight/FRACUNIT))*FRACUNIT)
				P_SetObjectMomZ(player.mo, player.flyheight, false)
			end
			if player.fly2 <= 0
			or (player.cmd.buttons & BT_CUSTOM3)
				player.fly2 = 0
				if not player.powers[pw_super]
					player.fly2u = true
				end
				player.mo.state = S_PLAY_FALL
				S_StopSoundByID(player.mo, sfx_putput)
				if player.fly2t1
					player.fly2 = 0
					player.fly2u = true
					player.fly = 6*TICRATE
					player.flyheight = 0*FRACUNIT
					P_InstaThrust(player.mo, player.mo.angle, (50 - abs(player.flyheight/FRACUNIT))*FRACUNIT)
					P_SetObjectMomZ(player.mo, player.flyheight, false)
					player.fly2t1 = false
				end
			end
		end
		if P_IsPlayerOnGround(player)
			player.fly2u = false
			player.pflags = $ & ~PF_CANCARRY
			player.fly2 = 0
		end
		if (player.mo.eflags & MFE_SPRUNG)
			player.fly2u = false
			player.pflags = $ & ~PF_CANCARRY
		end
		if player.fly > 0
			player.powers[pw_strong] = $|STR_SPIKE|STR_WALL
		end
		if player.fly == 1
			player.flyuse = $ + 1
		end
		if player.flyuse >= 2
			player.pflags = $|PF_THOKKED
			player.flyuse = 0
		end
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
		and not player.fly
			player.flyuse = 0
		end
		if P_IsPlayerOnGround(player)
		and player.fly
			player.fly = 0
		end
		if (player.mo.z + player.mo.height == player.mo.ceilingz
		or player.mo.z == player.mo.floorz)
		and player.fly
			player.flyheight = 0*FRACUNIT
		end
	end
end)

addHook("BotTiccmd", function(bot, cmd)
	if bot
	and bot.mo and bot.mo.valid
	and bot.mo.skin == "tails"
	and bot.botleader
	and bot.botleader.mo and bot.botleader.mo.valid
		local player = bot.botleader
		if bot.fly
			if not (player.powers[pw_carry] & CR_PLAYER)
				if (not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z > bot.mo.z
				or (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z < bot.mo.z)
				and bot.flyheight < abs(player.speed - player.mo.momz)
					cmd.buttons = $|BT_JUMP
				elseif (not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z < bot.mo.z
				or (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z > bot.mo.z)
				and bot.flyheight > player.speed - player.mo.momz
					cmd.buttons = $|BT_SPIN
				end
			end
		end
		if bot.fly2
			if not (player.powers[pw_carry] & CR_PLAYER)
			and not P_IsPlayerOnGround(player)
				bot.fly2 = $ + 1
			elseif P_IsPlayerOnGround(player)
				bot.fly2 = 0
			end
		end
		if abs(bot.speed - player.speed) > 20*FRACUNIT
		and player.speed > 50*FRACUNIT
			P_InstaThrust(bot.mo, R_PointToAngle2(bot.mo.x, bot.mo.y, player.mo.x, player.mo.y), player.speed - (5*FRACUNIT))
		end
		bot.charflags = $|SF_SUPER
		bot.powers[pw_super] = player.powers[pw_super]
		bot.rings = 50
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.mo.skin == "tails"
	and player.fly > 0
		return true
	end
end)

// Amy

addHook("SpinSpecial", function(player)
	if player.mo.skin ~= "amy" return end
	if (player.cmd.buttons & BT_USE)
	and P_IsPlayerOnGround(player)
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
	and not player.amyjumpcharge
		if player.speed < 70*FRACUNIT
			P_InstaThrust(player.mo, player.mo.angle, player.speed + (5*FRACUNIT))
		else
			P_InstaThrust(player.mo, player.mo.angle, player.speed)
		end
		if not (player.mo.eflags & MFE_UNDERWATER)
			P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
		else
			P_SetObjectMomZ(player.mo, (5*FRACUNIT)/2, false)
		end
		if player.amyleg == "left"
			player.mo.state = S_PLAY_AMYSKIP_L
			player.amyleg = "right"
		elseif player.amyleg == "right"
			player.mo.state = S_PLAY_AMYSKIP_R
			player.amyleg = "left"
		end
		player.amyskip = true
		player.amyhammerjump = false
		S_StartSound(player.mo, sfx_s3k4a)
		player.pflags = $|PF_JUMPED
		for a = 0, 19
			P_SpawnSkidDust(player, player.speed/3)
		end
		return true
	end
end)

addHook("SpinSpecial", function(player)
	if player.mo.skin ~= "amy" return end
	if player.spintics <= 2
	and not P_IsPlayerOnGround(player)
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
	and not player.amyjumpcharge
	and not (player.pflags & PF_THOKKED)
	and (not (player.mo.eflags & MFE_VERTICALFLIP)
	and player.mo.z >= player.mo.floorz + 30*FRACUNIT
	or (player.mo.eflags & MFE_VERTICALFLIP)
	and player.mo.z + player.mo.height <= player.mo.ceilingz - 30*FRACUNIT)
		player.amyjumpcharge = 15
		player.amyjumpspeed = player.speed
		S_StartSound(player.mo, sfx_ding)
		for angle = 1, 16
			local dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
			dust.scale = player.mo.scale/3
			P_InstaThrust(dust, ANGLE_22h*angle, 10*FRACUNIT)
			dust.tics = 15
		end
		player.amyskip = false
		return true
	end
	if (not (player.mo.eflags & MFE_VERTICALFLIP)
	and player.mo.z < player.mo.floorz + 30*FRACUNIT
	or (player.mo.eflags & MFE_VERTICALFLIP)
	and player.mo.z + player.mo.height > player.mo.ceilingz - 30*FRACUNIT)
	and not P_IsPlayerOnGround(player)
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin ~= "amy" return end
		if player.amyskip == nil
			player.amyskip = false
		end
		if player.amyleg == nil
			player.amyleg = "left"
		end
		if player.amyjumpcharge == nil
			player.amyjumpcharge = 0
		end
		if player.amyjumpspeed == nil
			player.amyjumpspeed = 0
		end
		if player.amyjumptimer == nil
			player.amyjumptimer = 0
		end
		if player.amyredirects == nil
			player.amyredirects = 0
		end
		if player.amyredirect == nil
			player.amyredirect = false
		end
		if player.amyredirecta == nil
			player.amyredirecta = 0
		end
		if player.amyhammerjump == nil
			player.amyhammerjump = false
		end
		if player.amyskip
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.amyskip = false
				return
			end
			if P_IsPlayerOnGround(player)
			and player.mo.momz == 0
				if player.amyhammerjump
					player.amyjumpspeed = player.speed
					player.amyjumptimer = 35 + ((player.speed/8)/FRACUNIT)
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo, sfx_sprong)
					player.pflags = $|PF_THOKKED|PF_JUMPED
					P_SetObjectMomZ(player.mo, 35*FRACUNIT, false)
					P_InstaThrust(player.mo, player.mo.angle, player.amyjumpspeed)
					player.amyhammerjump = false
					player.amyskip = false
				else
					player.mo.state = S_PLAY_WALK
					player.amyskip = false
				end
			else
				if player.mo.state ~= S_PLAY_TWINSPIN
					if player.amyleg == "right"
						player.mo.state = S_PLAY_AMYSKIP_L
					elseif player.amyleg == "left"
						player.mo.state = S_PLAY_AMYSKIP_R
					end
					player.amyhammerjump = false
				else
					player.amyhammerjump = true
				end
				SpawnGhost(player)
			end
		end
		if player.amyjumpcharge
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.amyjumpcharge = 0
				player.amyjumpspeed = 0
				return
			end
			player.amyjumpcharge = $ - 1
			player.mo.momx = $ - ($/15)
			player.mo.momy = $ - ($/15)
			player.mo.momz = $ - ($/15)
			player.mo.state = S_PLAY_AMYLAUNCH_1
			player.mo.frame = A
			if player.amyjumpcharge <= 0
				player.jumping = false
				P_SetObjectMomZ(player.mo, 35*FRACUNIT, false)
				P_InstaThrust(player.mo, player.mo.angle, player.amyjumpspeed)
				player.pflags = $|PF_THOKKED|PF_JUMPED
				player.amyjumptimer = 35 + ((player.speed/10)/FRACUNIT)
				player.mo.state = S_PLAY_AMYLAUNCH_2
				S_StartSound(player.mo, sfx_wdjump)
			end
		end
		if player.amyjumptimer
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.amyjumptimer = 0
				return
			end
			player.amyjumptimer = $ - 1
			player.jumping = false
			P_SetObjectMomZ(player.mo, (player.mo.eflags & MFE_UNDERWATER) and ((player.amyjumptimer*FRACUNIT)/2) + (player.speed/10) or not (player.mo.eflags & MFE_UNDERWATER) and (player.amyjumptimer*FRACUNIT) + (player.speed/10), false)
			player.pflags = $|PF_THOKKED|PF_JUMPED
			SpawnGhost(player)
			if leveltime%5 == 0
				for angle = 1, 16
					local heart = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PARTICLE)
					heart.destscale = (5*player.mo.scale) >> 4
					P_InstaThrust(heart, ANGLE_22h*angle, 10*FRACUNIT)
					heart.fuse = 15
					heart.state = S_LHRT
					heart.color = player.mo.color
				end
			end
		end
		if player.mo.state == S_PLAY_AMYLAUNCH_3
			if player.mo.momz <= 0
				player.mo.state = S_PLAY_FALL
				player.amyjumpspeed = 0
			end
			if (player.cmd.buttons & BT_JUMP)
				player.mo.state = S_PLAY_MELEE_LANDING
				player.amyredirects = 10
				player.amyjumptimer = 0
				if player.amyjumpspeed > player.runspeed
					player.amyjumpspeed = player.speed
				else
					player.amyjumpspeed = player.runspeed
				end
				P_SetObjectMomZ(player.mo, 0, false)
				P_InstaThrust(player.mo, 0, 0)
				S_StartSound(player.mo, sfx_skid)
			end
		end
		if player.amyredirects
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.amyredirects = 0
				return
			end
			player.amyredirects = $ - 1
			P_SetObjectMomZ(player.mo, 0, false)
			P_InstaThrust(player.mo, 0, 0)
			player.mo.state = S_PLAY_MELEE_LANDING
			player.drawangle = player.mo.angle - ANGLE_90
			if player.amyredirects <= 0
				player.amyredirect = true
				P_InstaThrust(player.mo, player.mo.angle, player.amyjumpspeed)
				player.mo.state = S_PLAY_AMYSPIN
				S_StartSound(player.mo, sfx_zoom)
			end
		end
		if player.amyredirect
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.amyredirect = false
				player.mo.flags = $ & ~MF_BOUNCE
				return
			end
			SpawnGhost(player)
			player.mo.state = S_PLAY_AMYSPIN
			player.mo.flags = $|MF_BOUNCE
			player.drawangle = player.amyredirecta
			player.amyredirecta = player.drawangle + ANGLE_22h
			if player.powers[pw_super]
			and (player.cmd.buttons & BT_JUMP)
				P_SetObjectMomZ(player.mo, FRACUNIT + (FRACUNIT/2), true)
				player.drawangle = player.amyredirecta
				player.amyredirecta = player.drawangle + ANGLE_22h
				local x,y = cos(player.drawangle), sin(player.drawangle)
				local heart = P_SpawnMobjFromMobj(player.mo, 30*x, 30*y, 0, MT_PARTICLE)
				heart.destscale = (5*player.mo.scale) >> 4
				heart.fuse = 4
				heart.state = S_LHRT
				heart.color = player.mo.color
			end
			if P_IsPlayerOnGround(player)
				player.amyredirect = false
				player.drawangle = player.mo.angle
				player.mo.state = S_PLAY_WALK
				player.mo.flags = $ & ~MF_BOUNCE
			end
			if abs(player.drawangle - player.mo.angle) <= ANGLE_22h
				for angle = 1, 16
					local heart = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PARTICLE)
					heart.destscale = (5*player.mo.scale) >> 4
					P_InstaThrust(heart, ANGLE_22h*angle, 10*FRACUNIT)
					heart.fuse = 15
					heart.state = S_LHRT
					heart.color = player.mo.color
				end
			end
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.mo.skin ~= "amy" return end
	if player.amyredirects
	or player.amyredirect
	or player.amyjumptimer
		return true
	end
end)

// Metal Sonic

addHook("SpinSpecial", function(player)
	if player.mo.skin ~= "metalsonic" return end
	if player.spintics == 1
	and not P_IsPlayerOnGround(player)
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
	and not player.metalblastcharge
	and not player.metalblast
	and player.mo.state ~= S_PLAY_PAIN
		player.metalblastcharge = 10
		player.mo.state = S_PLAY_SUPER_TRANS1
		S_StartSound(player.mo, sfx_ding)
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin ~= "metalsonic" return end
		if player.metalblast == nil
			player.metalblast = false
		end
		if player.metalblastcharge == nil
			player.metalblastcharge = 0
		end
		if player.metalblastfloat == nil
			player.metablastfloat = 0
		end
		if player.metalblastcharge
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.metalblastcharge = 0
				return
			end
			player.metalblastcharge = $ - 1
			player.mo.state = S_PLAY_SUPER_TRANS1
			player.mo.frame = A
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			P_SetObjectMomZ(player.mo, 0, false)
			if player.metalblastcharge == 0
				player.metalblast = true
				player.mo.state = S_PLAY_DASH
				P_InstaThrust(player.mo, player.mo.angle, 70*FRACUNIT)
				P_SetObjectMomZ(player.mo, 0, false)
				if consoleplayer == player
					P_StartQuake(45*FRACUNIT, TICRATE/2)
				end
				S_StartSound(player.mo, sfx_s3k54)
			end
		end
		if player.metalblast
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
			or (player.cmd.buttons & BT_CUSTOM3)
				player.metalblast = 0
				return
			end
			if player.powers[pw_pushing]
				player.metalblast = 0
				P_DoPlayerPain(player)
				player.powers[pw_flashing] = 0
				return
			end
			if P_IsPlayerOnGround(player)
				player.metalblast = 0
				P_SetObjectMomZ(player.mo, 0, false)
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 70*FRACUNIT)
				else
					P_InstaThrust(player.mo, player.mo.angle, 35*FRACUNIT)
				end
				return
			end
			if player.powers[pw_super]
				player.metalblastfloat = 2
			end
			SpawnGhost(player)
			player.mo.state = S_PLAY_DASH
			player.pflags = $|PF_JUMPED
			if not (player.cmd.buttons & BT_JUMP)
			and not (player.cmd.buttons & BT_USE)
			or (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.z >= player.mo.floorz + 256*FRACUNIT
			or (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.z + player.mo.height <= player.mo.ceilingz - 256*FRACUNIT)
			or player.powers[pw_super])
				if not (player.mo.eflags & MFE_UNDERWATER)
					if (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z >= player.mo.floorz + 306*FRACUNIT
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + player.mo.height <= player.mo.ceilingz - 306*FRACUNIT)
					or player.powers[pw_super])
					and not player.metalblastfloat
						P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
					else
						P_InstaThrust(player.mo, player.mo.angle, 55*FRACUNIT)
					end
					if (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z >= player.mo.floorz + 306*FRACUNIT
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + player.mo.height <= player.mo.ceilingz - 306*FRACUNIT)
					or player.powers[pw_super])
						if not player.metalblastfloat
							P_SetObjectMomZ(player.mo, -25*FRACUNIT, false)
						else
							player.metalblastfloat = $ - 1
							P_SetObjectMomZ(player.mo, 0, false)
						end
					else
						player.metalblastfloat = 1*TICRATE
						P_SetObjectMomZ(player.mo, 0, false)
					end
				else
					if (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z >= player.mo.floorz + 306*FRACUNIT
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + player.mo.height <= player.mo.ceilingz - 306*FRACUNIT)
					or player.powers[pw_super])
					and not player.metalblastfloat
						P_InstaThrust(player.mo, player.mo.angle, (55*FRACUNIT)/2)
					else
						P_InstaThrust(player.mo, player.mo.angle, 35*FRACUNIT)
					end
					if (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z >= player.mo.floorz + 306*FRACUNIT
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + player.mo.height <= player.mo.ceilingz - 306*FRACUNIT)
					or player.powers[pw_super])
						if not player.metalblastfloat
							P_SetObjectMomZ(player.mo, (-25*FRACUNIT)/2, false)
						else
							player.metalblastfloat = $ - 1
							P_SetObjectMomZ(player.mo, 0, false)
						end
					else
						player.metalblastfloat = 1*TICRATE
						P_SetObjectMomZ(player.mo, 0, false)
					end
				end
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if (player.cmd.buttons & BT_JUMP)
				and (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z < player.mo.floorz + 256*FRACUNIT
				or (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z + player.mo.height > player.mo.ceilingz - 256*FRACUNIT)
				or player.powers[pw_super])
					P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
					if (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + 25*FRACUNIT <= player.mo.floorz + 256*FRACUNIT
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + player.mo.height - 25*FRACUNIT >= player.mo.ceilingz - 256*FRACUNIT)
					or player.powers[pw_super])
						P_SetObjectMomZ(player.mo, 25*FRACUNIT, false)
					else
						P_SetObjectMomZ(player.mo, 1*FRACUNIT, false)
					end
				end
			else
				if (player.cmd.buttons & BT_JUMP)
				and (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z < player.mo.floorz + 256*FRACUNIT
				or (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.z + player.mo.height > player.mo.ceilingz - 256*FRACUNIT)
				or player.powers[pw_super])
					P_InstaThrust(player.mo, player.mo.angle, (55*FRACUNIT)/2)
					if (not player.powers[pw_super] and (not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + 25*FRACUNIT <= player.mo.floorz + 256*FRACUNIT
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.z + player.mo.height - 25*FRACUNIT >= player.mo.ceilingz - 256*FRACUNIT)
					or player.powers[pw_super])
						P_SetObjectMomZ(player.mo, (25*FRACUNIT)/2, false)
					else
						P_SetObjectMomZ(player.mo, FRACUNIT/2, false)
					end
				end
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if (player.cmd.buttons & BT_USE)
					P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
					P_SetObjectMomZ(player.mo, -25*FRACUNIT, false)
				end
			else
				if (player.cmd.buttons & BT_USE)
					P_InstaThrust(player.mo, player.mo.angle, (55*FRACUNIT)/2)
					P_SetObjectMomZ(player.mo, (-25*FRACUNIT)/2, false)
				end
			end
		end
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if not (player.charflags & SF_DASHMODE) continue end
		if (player.metalblast
		or (not player.powers[pw_underwater]
		and FixedRound(player.speed) >= 50*FRACUNIT
		or player.powers[pw_underwater]
		and FixedRound(player.speed) >= 30*FRACUNIT
		or FixedRound(player.speed) >= player.runspeed
		and player.powers[pw_super]))
			if not player.powers[pw_pushing]
				player.dashmode = 3*TICRATE
			end
			if player.metalblast
				player.cmd.forwardmove = 50
			end
		end
	end
end)

// Shadow (shocker!!!!!!)

addHook("SpinSpecial", function(player)
	if player.mo.skin ~= "shadow" return end
	if player.spintics == 1
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
	and not player.powers[pw_pushing]
	and not player.shadowboostair
	and not player.shadowboost
	and (player.cmd.forwardmove or player.cmd.sidemove)
		S_StartSound(player.mo, sfx_bkpoof)
		local shockwave = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PARTICLE)
		shockwave.state = S_SHADOW_BOOSTSHOCKWAVE
		shockwave.angle = player.mo.angle + ANGLE_90
		shockwave.color = SKINCOLOR_WHITE
		shockwave.colorized = true
		if not (player.mo.eflags & MFE_UNDERWATER)
			if player.speed < 50*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
			else
				P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.mo.momx, player.mo.momy))
			end
		else
			if player.speed < 35*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, 35*FRACUNIT)
			else
				P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.mo.momx, player.mo.momy))
			end
		end
		player.shadowboosts = shockwave
		player.shadowboost = true
		if consoleplayer == player
			P_StartQuake(45*FRACUNIT, TICRATE/2)
		end
		player.camerascale = 5*FRACUNIT/2
		if not P_IsPlayerOnGround(player)
			player.shadowboostair = true
			player.mo.state = S_PLAY_DASH
			if not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			else
				P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
			end
		end
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.mo.skin ~= "shadow" continue end
			if player.charability2 ~= CA2_NONE
				player.charability2 = CA2_NONE
			end
			if player.shadowboost == nil
				player.shadowboost = false
			end
			if player.shadowboostair == nil
				player.shadowboostair = false
			end
			if player.shadowrailboost == nil
				player.shadowrailboost = false
			end
			if P_IsPlayerOnGround(player)
			or (player.mo.eflags & MFE_SPRUNG)
				player.shadowboostair = false
			end
			if player.shadowboost
				if P_PlayerInPain(player)
				or player.powers[pw_carry]
					player.shadowboost = false
					S_StopSoundByID(player.mo, sfx_s3kcfl)
					player.camerascale = FRACUNIT
					if player.shadowboosta ~= nil
					and player.shadowboosta and player.shadowboosta.valid
						P_RemoveMobj(player.shadowboosta)
					end
					continue
				end
				if player.shadowboosta ~= nil
				and player.shadowboosta and player.shadowboosta.valid
					P_RemoveMobj(player.shadowboosta)
				end
				local dist = max(player.speed / (4*FRACUNIT), 1)
				player.shadowboosta = P_SpawnMobjFromMobj(player.mo, player.mo.momx/dist, player.mo.momy/dist, player.mo.momz/dist, MT_PARTICLE)
				player.shadowboosta.state = S_SHADOW_BOOSTAURA
				player.shadowboosta.angle = player.drawangle
				if player.shadow_skatecolor ~= nil
					player.shadowboosta.color = player.shadow_skatecolor
				end
				if not (player.mo.eflags & MFE_UNDERWATER)
					if player.speed < 90*FRACUNIT
						P_Thrust(player.mo, player.drawangle, FRACUNIT/7)
					end
				else
					if player.speed < 90*FRACUNIT
						P_Thrust(player.mo, player.drawangle, FRACUNIT/14)
					end
				end
				if P_IsPlayerOnGround(player)
					if not (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.ceilingz < player.mo.z + skins[player.mo.skin].height
					or (player.mo.eflags & MFE_VERTICALFLIP)
					and player.mo.floorz > player.mo.z
						if player.mo.state ~= S_PLAY_ROLL
							player.mo.state = S_PLAY_ROLL
						end
					else
						if player.mo.state ~= S_PLAY_RUN
							player.mo.state = S_PLAY_RUN
						end
					end
				end
				player.height = P_GetPlayerSpinHeight(player)
				if not S_SoundPlaying(player.mo, sfx_s3kcfl)
					S_StartSound(player.mo, sfx_s3kcfl)
				end
				if player.speed < 50*FRACUNIT
				and player.spintics > 5
					P_Thrust(player.mo, player.drawangle, (50 - (player.speed/FRACUNIT))*FRACUNIT)
				end
				if player.camerascale > FRACUNIT
					player.camerascale = $ - FRACUNIT/20
				end
				if player.camerascale < FRACUNIT
					player.camerascale = FRACUNIT
				end
				if not (player.cmd.buttons & BT_USE)
				or not player.cmd.forwardmove 
				and not player.cmd.sidemove
				or player.powers[pw_pushing]
					if player.mo.state == S_PLAY_DASH
						player.mo.state = S_PLAY_FALL
					end
					player.shadowboost = false
					player.camerascale = FRACUNIT
					S_StopSoundByID(player.mo, sfx_s3kcfl)
					if player.shadowboosta ~= nil
						P_RemoveMobj(player.shadowboosta)
					end
					player.height = skins[player.mo.skin].height
					if P_IsPlayerOnGround(player)
						player.mo.state = S_PLAY_WALK
					end
				end
			end
			if player.shadow ~= nil
			and player.shadow.snaps < 2
			and not player.powers[pw_super]
				player.shadow.snaps = 0
			end
			if player.homing 
			or (player.shadow ~= nil
			and player.shadow.battlehoming)
				player.shadowboostair = false
				player.shadow.snaps = 2
				player.cmd.buttons = $|BT_JUMP
			end
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.mo.skin ~= "shadow" return end
	if player.shadowboost
		return true
	end
end)

// Silver

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin ~= "silver" return end
		if player.mo.silv_floatstate ~= nil
		and not player.powers[pw_super]
			if player.mo.silv_floatstate == 1
				player.mo.silv_energy = min($ + 1, 350)
				player.mo.silv_regendelay = 15
				player.powers[pw_carry] = $|CR_PLAYER
			end
			if player.mo.silv_floatstate == 2
				player.mo.silv_energy = max($ + 5, 0)
				player.mo.silv_regendelay = 15
				player.powers[pw_carry] = $ & ~CR_PLAYER
			end
		end
		if player.mo.silv_usedelay ~= nil
		and player.mo.silv_usedelay > 2
			player.mo.silv_usedelay = 2
		end
		if player.mo.silv_regendelay ~= nil
			if player.mo.silv_regendelay > 0
				if P_IsPlayerOnGround(player)
					player.mo.silv_regendelay = 0
				else
					if player.mo.silv_regendelay > 15
						player.mo.silv_regendelay = 15
					else
						player.mo.silv_regendelay = $ - 1
					end
				end
			end
			if player.mo.silv_regendelay == 0
			and not P_IsPlayerOnGround(player)
				local sneakerfactor = 1
				if player.powers[pw_sneakers]
					sneakerfactor = 3 
				end
				player.mo.silv_energy = min(SILVER_MAX_ENERGY, $ + SILVER_REGEN_RATE*sneakerfactor)
			end
		end
	end
end)

// Knuckles

addHook("JumpSpecial", function(player)
	if player.mo.skin ~= "knuckles" return end
	if not P_IsPlayerOnGround(player)
	and not player.powers[pw_carry]
	and not P_PlayerInPain(player)
	and not (player.pflags & PF_THOKKED)
	and not player.knuxglide
	and not player.knuxglidec
	and player.jumptics == 1
		player.knuxglide = true
		player.knuxglides = FixedHypot(player.mo.momx, player.mo.momy)
		P_InstaThrust(player.mo, player.mo.angle, player.knuxglides)
		player.mo.momz = $/2
		S_StartSound(player.mo, sfx_kxglde)
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin ~= "knuckles" return end
		if player.knuxglide == nil
			player.knuxglide = false
		end
		if player.knuxglides == nil
			player.knuxglides = 0
		end
		if player.knuxglidec == nil
			player.knuxglidec = false
		end
		if player.knuxglide
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.knuxglide = false
				S_StopSoundByID(player.mo, sfx_kxglde)
				return
			end
			player.drawangle = player.mo.angle
			if player.knuxglides > player.normalspeed
				player.knuxglides = $ + FRACUNIT/8
			else
				player.knuxglides = $ + FRACUNIT
			end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if player.mo.state ~= S_PLAY_GLIDE
					player.mo.state = S_PLAY_GLIDE
				end
			else
				if player.mo.state ~= S_PLAY_SWIM
					player.mo.state = S_PLAY_SWIM
				end
			end
			P_InstaThrust(player.mo, player.mo.angle, player.knuxglides)
			if not (player.mo.eflags & MFE_UNDERWATER)
				if not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.momz > -2*FRACUNIT
				or (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.momz < 2*FRACUNIT
					P_SetObjectMomZ(player.mo, FRACUNIT/3, true)
				else
					P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
				end
			else
				if not (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.momz > -2*FRACUNIT
				or (player.mo.eflags & MFE_VERTICALFLIP)
				and player.mo.momz < 2*FRACUNIT
					P_SetObjectMomZ(player.mo, FRACUNIT/6, true)
				else
					P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
				end
			end
			if not S_SoundPlaying(player.mo, sfx_kxglde)
				S_StartSound(player.mo, sfx_kxglde)
			end
			if P_IsPlayerOnGround(player)
				player.mo.state = S_PLAY_WALK
				player.knuxglide = false
				S_StopSoundByID(player.mo, sfx_kxglde)
			end
			if not (player.cmd.buttons & BT_JUMP)
				player.mo.state = S_PLAY_FALL
				player.knuxglide = false
				S_StopSoundByID(player.mo, sfx_kxglde)
			end
			if player.powers[pw_pushing]
				player.knuxglidec = true
				player.knuxglide = false
				S_StopSoundByID(player.mo, sfx_kxglde)
				player.mo.state = S_PLAY_CLIMB
				player.jumptics = 2
			end
		end
		if player.knuxglidec
			if P_PlayerInPain(player)
			or player.powers[pw_carry]
				player.knuxglidec = false
				S_StopSoundByID(player.mo, sfx_s3k4a)
				return
			end
			if not player.powers[pw_pushing]
				P_InstaThrust(player.mo, player.mo.angle, player.knuxglides)
				P_SetObjectMomZ(player.mo, -FRACUNIT, false)
				player.mo.state = S_PLAY_ROLL
				S_StopSoundByID(player.mo, sfx_s3k4a)
				player.knuxglidec = false
				return
			end
			if player.knuxglides > player.normalspeed
				player.knuxglides = $ + FRACUNIT/4
			else
				player.knuxglides = $ + 2*FRACUNIT
			end
			if not S_SoundPlaying(player.mo, sfx_s3k4a)
				S_StartSound(player.mo, sfx_s3k4a)
			end
			player.drawangle = player.mo.angle
			P_InstaThrust(player.mo, player.mo.angle, player.knuxglides)
			if player.cmd.forwardmove > 0
				if player.mo.state ~= S_PLAY_CLIMB
					player.mo.state = S_PLAY_CLIMB
				end
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, player.knuxglides/2, false)
				else
					P_SetObjectMomZ(player.mo, player.knuxglides/4, false)
				end
			elseif player.cmd.forwardmove < 0
				if player.mo.state ~= S_PLAY_CLIMB
					player.mo.state = S_PLAY_CLIMB
				end
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, -player.knuxglides/2, false)
				else
					P_SetObjectMomZ(player.mo, -player.knuxglides/4, false)
				end
			else
				player.knuxglides = 0
				P_SetObjectMomZ(player.mo, 0, false)
				if player.mo.state ~= S_PLAY_CLING
					player.mo.state = S_PLAY_CLING
				end
			end
			if player.jumptics == 1
				player.drawangle = $ + ANGLE_180
				player.mo.angle = player.drawangle
				P_InstaThrust(player.mo, player.drawangle, player.knuxglides)
				P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
				player.mo.state = S_PLAY_JUMP
				S_StartSound(player.mo, sfx_jump)
				player.pflags = $|PF_JUMPED
				player.knuxglidec = false
				S_StopSoundByID(player.mo, sfx_s3k4a)
			end
		end
	end
end)

// Kirby

addHook("PostThinkFrame", function(player)
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.kirbspindash == nil
				player.kirbspindash = false
			end
			if player.kirbspincharge == nil
				player.kirbspincharge = 0
			end
			if player.mo.skin ~= "kirby" continue end
			if player.kvars.ducking
			and not player.kirbspindash
			and P_IsPlayerOnGround(player)
			and player.spintics == 1
				player.kirbspindash = true
				S_StartSound(player.mo, sfx_spndsh)
				player.pflags = $|PF_FULLSTASIS|PF_STARTDASH
				player.kirbspincharge = 20
				continue
			end
			if player.kirbspindash
				if P_PlayerInPain(player)
				or player.powers[pw_carry]
				or not P_IsPlayerOnGround(player)
					player.kirbspindash = false
					player.kirbspincharge = 0
					continue
				end
				P_SpawnSkidDust(player, 10*FRACUNIT)
				player.drawangle = player.mo.angle
				player.pflags = $|PF_FULLSTASIS|PF_STARTDASH
				if not (player.mo.state >= S_KIRBY_WHEEL1 and player.mo.state <= S_KIRBY_WHEEL4)
					player.mo.state = S_KIRBY_WHEEL1
				end
				if player.spintics == 1
					S_StartSound(player.mo, sfx_spndsh)
					if player.kirbspincharge < 70
						player.kirbspincharge = $ + 10
					end
				end
				if not (player.cmd.buttons & BT_CUSTOM2)
					P_InstaThrust(player.mo, player.mo.angle, (player.kirbspincharge*FRACUNIT) + FixedHypot(player.mo.momx, player.mo.momy))
					S_StartSound(player.mo, sfx_zoom)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $ & ~(PF_FULLSTASIS|PF_STARTDASH)
					player.pflags = $|PF_SPINNING
					player.kirbspindash = false
					player.kirbspincharge = 0
				end
			end
		end
	end
end)