rawset(_G, "LivinTheDreamLoaded", true)
// Table for compatible characters
rawset(_G, "ManiaChars", {
    ["sonic"] = true,
	["tails"] = true,
	["knuckles"] = true,
	["fang"] = true,
	["amy"] = true,
	["metalsonic"] = true,
	["shadow"] = true,
	["silver"] = true
})

// Get done with those freeslots

freeslot(
	"S_MANIA_DUST",
	"MT_MANIA_DUST",
	"SPR_DSHR",
	"S_PLAY_WIND",
	"SPR_FAST",
	"MT_INSTASHIELD",
	"S_INSTASHIELD",
	"SPR_TWSP",
	"S_PLAY_CROUCH",
	"sfx_dpds",
	"SPR2_CRCH",
	"S_PLAY_CROUCH_START",
	"S_PLAY_CROUCH_END",
	"S_PLAY_PEELOUT_WALK",
	"S_PLAY_PEELOUT_RUN",
	"SPR2_PUSH",
	"S_PLAY_PUSH",
	"SPR2_ALSP",
	"SPR2_ARSP",
	"S_PLAY_AMYSKIP_L",
	"S_PLAY_AMYSKIP_R",
	"SPR2_ALCH",
	"SPR2_ALFH",
	"S_PLAY_AMYLAUNCH_1",
	"S_PLAY_AMYLAUNCH_2",
	"S_PLAY_AMYLAUNCH_3",
	"S_PLAY_AMYSPIN",
	"S_SHADOW_BOOSTAURA",
	"S_SHADOW_BOOSTSHOCKWAVE",
	"sfx_spdd",
	"S_PLAY_TAILS_TIRED",
	"sfx_kxglde",
	"sfx_kbchge",
	"MT_KIRBYSPITSTAR",
	"SPR_LDSD"
)

// The Sound Effect info

sfxinfo[sfx_dpds].caption = "Drop Dash Charge"

// The States and Mobjs

states[S_MANIA_DUST] = {
	sprite = SPR_DSHR,
	frame = FF_PAPERSPRITE|FF_ANIMATE|A,
	var1 = 6,
	var2 = 2,
	tics = 12,
	nextstate = S_DEATHSTATE
}

mobjinfo[MT_MANIA_DUST] = {
	doomednum = -1,
	spawnstate = S_MANIA_DUST,
	spawnhealth = 9999,
	radius = 32*FU,
	flags = MF_NOGRAVITY
}

states[S_INSTASHIELD] = {
	sprite = SPR_TWSP, 
	frame = FF_FULLBRIGHT|FF_ANIMATE, 
	tics = 7, 
	var1 = 7, 
	var2 = 1, 
	nextstate = S_NULL
}

mobjinfo[MT_INSTASHIELD] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INSTASHIELD,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_SCENERY|MF_NOCLIPHEIGHT
}

states[S_PLAY_WIND] = {
	sprite = SPR_FAST,
	frame = A|FF_ANIMATE|FF_PAPERSPRITE,
	tics = 10,
	var1 = 4,
	var2 = 2,
	nextstate = S_NULL
}

states[S_PLAY_CROUCH] = {
	sprite = SPR_PLAY,
	frame = SPR2_LAND,
	tics = -1,
	nextstate = S_PLAY_STND
}

states[S_PLAY_CROUCH_START] = {
	sprite = SPR_PLAY,
	frame = SPR2_CRCH|FF_ANIMATE,
	tics = 4,
	var1 = 0,
	var2 = 4,
	nextstate = S_PLAY_CROUCH
}

states[S_PLAY_CROUCH_END] = {
	sprite = SPR_PLAY,
	frame = SPR2_CRCH|FF_ANIMATE,
	tics = 4,
	var1 = 0,
	var2 = 4,
	nextstate = S_PLAY_STND
}

states[S_PLAY_PEELOUT_WALK] = {
	sprite = SPR_PLAY,
	frame = SPR2_WALK,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_PEELOUT_WALK
}

states[S_PLAY_PEELOUT_RUN] = {
	sprite = SPR_PLAY,
	frame = SPR2_RUN_,
	tics = 2,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_PEELOUT_RUN
}

states[S_PLAY_PUSH] = {
	sprite = SPR_PLAY,
	frame = SPR2_PUSH,
	tics = 32,
	var1 = 8,
	var2 = 4,
	nextstate = S_PLAY_PUSH
}

states[S_PLAY_AMYSKIP_L] = {
	sprite = SPR_PLAY,
	frame = SPR2_ALSP,
	tics = 10,
	var1 = 1,
	var2 = 10,
	nextstate = S_PLAY_AMYSKIP_L
}

states[S_PLAY_AMYSKIP_R] = {
	sprite = SPR_PLAY,
	frame = SPR2_ARSP,
	tics = 10,
	var1 = 1,
	var2 = 10,
	nextstate = S_PLAY_AMYSKIP_R
}

states[S_PLAY_AMYLAUNCH_1] = {
	sprite = SPR_PLAY,
	frame = SPR2_ALCH|A,
	tics = 1,
	var1 = 1,
	var2 = 1,
	nextstate = S_PLAY_AMYLAUNCH_1
}

states[S_PLAY_AMYLAUNCH_2] = {
	sprite = SPR_PLAY,
	frame = SPR2_ALCH|FF_ANIMATE,
	tics = 14,
	var1 = 4,
	var2 = 4,
	nextstate = S_PLAY_AMYLAUNCH_3
}

states[S_PLAY_AMYLAUNCH_3] = {
	sprite = SPR_PLAY,
	frame = SPR2_ALFH|A,
	tics = 19,
	var1 = 1,
	var2 = 1,
	nextstate = S_PLAY_AMYLAUNCH_3
}

states[S_PLAY_AMYSPIN] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_MLEL,
	tics = 35,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_WALK
}

states[S_SHADOW_BOOSTAURA] = {
	sprite = SPR_FIRS,
	frame = FF_TRANS40|FF_FULLBRIGHT|18,
	tics = 1,
	action = nil,
	var1 = 1,
	var2 = 0,
	nextstate = S_SHADOW_BOOSTAURA
}

states[S_SHADOW_BOOSTSHOCKWAVE] = {
	sprite = SPR_BAL2,
	frame = FF_PAPERSPRITE|FF_ANIMATE|FF_FULLBRIGHT|2,
	tics = 8,
	action = nil,
	var1 = 4,
	var2 = 2,
	nextstate = S_NULL
}

states[S_PLAY_TAILS_TIRED] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_TIRE,
	tics = 12,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_TAILS_TIRED
}

// The functions

rawset(_G, "P_IsPlayerManiafied", function(player)
	if player.mo and player.mo.valid
		local skin = player.mo.skin
		if ManiaChars[skin]
		or (skin == "s3sonic"
		or skin == "s1sonic"
		or skin == "cdsonic")
		and player.allclassics
			return true
		else
			return false
		end
	end
end)

rawset(_G, "AllClassics", function(player)
	if player.allclassics
		return true
	else
		return false
	end
end)

rawset(_G, "coollookindust", function(player)
local mo = player.mo
	if not player.powers[pw_underwater]
		if P_IsObjectOnGround(mo)
			for i = -1, 1, 2
				local ang = i * ANG10
				local factor = FixedMul(4*mo.scale, cos(ang))
				local x = P_ReturnThrustX(mo, player.drawangle + ang, 24*mo.scale)
				local y = P_ReturnThrustY(mo, player.drawangle + ang, 24*mo.scale)
				local dust = P_SpawnMobjFromMobj(mo, -x, -y, 0, MT_MANIA_DUST)
				dust.scale = 2*$/(5/2)
				dust.angle = R_PointToAngle2(dust.x, dust.y, mo.x, mo.y)
				dust.state = S_MANIA_DUST
				if not player.fakespin
					dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_135))
					dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_135))
				end
			end
		end
	else
		P_SpawnSkidDust(player, 20*FRACUNIT)
	end
end)

rawset(_G, "coolspeedwindlines", function(p)
	local mo = p.mo
	local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), mo.momz)
	local dist = max(p.speed / (4*FRACUNIT), 1)
	
	local btrail = P_SpawnMobj(p.mo.x + (P_RandomRange(-36,36) * p.mo.scale), p.mo.y + (P_RandomRange(-36,36) * p.mo.scale), p.mo.z + (p.mo.height/2) + (P_RandomRange(-20,20) * p.mo.scale), MT_SMOKE)
	btrail.state = S_PLAY_WIND
	btrail.angle = p.drawangle
	btrail.colorized = true
	btrail.color = p.mo.color
	btrail.fuse = 7
	btrail.frame = $|FF_FULLBRIGHT
	btrail.blendmode = AST_ADD
	btrail.target = mo
	btrail.scale = p.mo.scale
end)

rawset(_G, "P_IsPlayerOnGround", function(player)
	local returnvalue = false
	if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo) or (not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.z == player.mo.floorz or (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.z + player.mo.height == player.mo.ceilingz))
		returnvalue = true
	end
	if player.mo.subsector.sector
		local sec = player.mo.subsector.sector
		for fof in sec.ffloors()
			if (fof.flags & FOF_EXISTS)
			and (fof.flags & FOF_SWIMMABLE)
			and (not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.z == fof.topheight
			or (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.z + player.mo.height == fof.bottomheight)
				returnvalue = true
			end
		end
	end
	return returnvalue
end)

rawset(_G, "P_CheckHeight", function(touched, toucher)
	if touched.z <= toucher.z + toucher.height
	and touched.z + touched.height >= toucher.z
		return true
	else
		return false
	end
end)

rawset(_G, "M_SpringType", function(mobj)
	if mobj and mobj.valid
		local type = mobj.type
		if type == MT_YELLOWSPRING
		or type == MT_REDSPRING
		or type == MT_BLUESPRING
			return "verti"
		elseif type == MT_YELLOWDIAG
		or type == MT_REDDIAG
		or type == MT_BLUEDIAG
			return "diag"
		elseif type == MT_YELLOWHORIZ
		or type == MT_BLUEHORIZ
		or type == MT_REDHORIZ
			return "horiz"
		end
	end
end)

rawset(_G, "M_SpawnGhost", function(player)
	local ghost = P_SpawnGhostMobj(player.mo)
	return ghost
end)

rawset(_G, "GetWallAngle", function(mo, line)
	local mobjAngle = R_PointToAngle2(line.v1.x, line.v1.y , line.v2.x, line.v2.y)
	if(#line.frontsector == #mo.subsector.sector)
		mobjAngle = $ + ANGLE_90
		mo.lineside = 0
	elseif (line.backsector ~= nil) and (#line.backsector == #mo.subsector.sector)
		mobjAngle = $ - ANGLE_90
		mo.lineside = 1
	else //just in case
		mobjAngle = $ + ANGLE_90
		mo.lineside = 0
	end
	return mobjAngle
end)

rawset(_G, "GetFloorSlopeXY", function(mo)
	local slope = mo.player.prevslope
	local zangle = slope.zangle
	local xyangle = slope.xydirection
	if (slope.flags & SL_NOPHYSICS) or (zangle == 0)
		return nil
	end
	if zangle < 0 
		xyangle = $ + ANGLE_180
	end
	if mo.eflags & MFE_VERTICALFLIP
		xyangle = $ + ANGLE_180
	end
	return xyangle
end)

rawset(_G, "thicc", function(p) -- Credit goes to NeonSRB2 for the Squash and Stretch code
	if not P_IsPlayerManiafied(p) then
		return
	end
	if p.jt == nil then
		p.jt = 0
		p.jp = false
		p.tk = false
		p.tr = false
	end
	if p.jt > 0 then
		p.jt = p.jt - 1
	end
	if p.jt < 0 then
		p.jt = p.jt + 1
	end
	if p.mo.momz < 1 then
		p.jp = false
	end
	if p.mo.state != S_PLAY_CLIMB and p.mo.eflags != p.mo.eflags | MFE_GOOWATER then
		if p.mo.momz > 0 and p.jp == false and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
		if p.mo.momz > 0 and p.jt < 0 and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
	elseif p.mo.eflags == p.mo.eflags | MFE_GOOWATER
		p.jp = true
	end
	if p.mo.state == S_PLAY_BOUNCE_LANDING then
		p.jt = -5
	end
	/*
	if p.pflags != p.pflags | PF_SPINNING or p.pflags == p.pflags | PF_JUMPED then
		p.sp = false
	end
	if p.pflags == p.pflags | PF_SPINNING and p.pflags != p.pflags | PF_JUMPED and p.sp == false and p.jt < 1 then
		p.sp = true
		p.jt = -5
	end
	*/
	if p.pflags != p.pflags | PF_THOKKED then
		p.tk = false
	end
	if p.pflags == p.pflags | PF_THOKKED and p.tk == false then
		p.tk = true
		p.jt = 5
	end
	if p.mo.state != S_PLAY_FLY_TIRED then
		p.tr = false
	end
	if p.mo.state == S_PLAY_FLY_TIRED and p.tr == false then
		p.tr = true
		p.jt = 5
	end
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.mo.spriteyscale = p.maths + FRACUNIT
	
	p.maths = p.jt*p.spinheight
	if p.mo.state != S_PLAY_ROLL then
		p.maths = p.jt*p.height
	end
	p.maths = p.maths / 20
	p.mo.spriteyoffset = -1*p.maths
	
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.maths = p.maths*-1
	p.mo.spritexscale = p.maths + FRACUNIT
end)

// HPU rq

rawset(_G, "GetWallAngle", function(mo, line)
	local mobjAngle = R_PointToAngle2(line.v1.x, line.v1.y , line.v2.x, line.v2.y)
	if(#line.frontsector == #mo.subsector.sector)
		mobjAngle = $ + ANGLE_90
		mo.lineside = 0
	elseif (line.backsector ~= nil) and (#line.backsector == #mo.subsector.sector)
		mobjAngle = $ - ANGLE_90
		mo.lineside = 1
	else //just in case
		mobjAngle = $ + ANGLE_90
		mo.lineside = 0
	end
	return mobjAngle
end)

rawset(_G, "GetFloorSlopeXY", function(mo)
	local slope = mo.player.prevslope
	local zangle = slope.zangle
	local xyangle = slope.xydirection
	if (slope.flags & SL_NOPHYSICS) or (zangle == 0)
		return nil
	end
	if zangle < 0 
		xyangle = $ + ANGLE_180
	end
	if mo.eflags & MFE_VERTICALFLIP
		xyangle = $ + ANGLE_180
	end
	return xyangle
end)

rawset(_G, "SpawnGhost", function(player)
	local ghost = P_SpawnGhostMobj(player.mo)
	ghost.color = player.mo.color
	ghost.colorized = true
	ghost.fuse = 7
	return ghost
end)

rawset(_G, "DrawInFont", function(scaled, pos, scale, v, strin, x, y, font, flags, spacing, c)
	local xcord = x
	local str = tostring(strin)
	for i=1,#str do
		if c ~= nil
			if scaled
				if pos
					v.drawScaled(xcord*FRACUNIT, y*FRACUNIT, FRACUNIT*scale, v.cachePatch( string.format(font.."%03d", str:byte(i,i)) ), flags, c)
				else
					v.drawScaled(xcord*FRACUNIT, y*FRACUNIT, FRACUNIT/scale, v.cachePatch( string.format(font.."%03d", str:byte(i,i)) ), flags, c)
				end
			else
				v.draw(xcord, y, v.cachePatch( string.format(font.."%03d", str:byte(i,i)) ), flags, c)
			end
		else
			if scaled
				if pos
					v.drawScaled(xcord*FRACUNIT, y*FRACUNIT, FRACUNIT*scale, v.cachePatch( string.format(font.."%03d", str:byte(i,i)) ), flags)
				else
					v.drawScaled(xcord*FRACUNIT, y*FRACUNIT, FRACUNIT/scale, v.cachePatch( string.format(font.."%03d", str:byte(i,i)) ), flags)
				end
			else
				v.draw(xcord, y, v.cachePatch( string.format(font.."%03d", str:byte(i,i)) ), flags)
			end
		end
		xcord = $ + spacing
	end
end)

// Setup all the options

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.momentum == nil
			player.momentum = true
		end
		if player.anglestand == nil
			player.anglestand = true
		end
		if player.airwalk == nil
			player.airwalk = false
		end
		if player.fallback == nil
			player.fallback = true
		end
		if player.shoes == nil
			player.shoes = true
		end
		if player.classic == nil
			player.classic = true
		end
		if player.cd == nil
			player.cd = true
		end
		if player.sp == nil
			player.sp = false
		end
		if player.reroll == nil
			player.reroll = false
		end
		if player.crouching == nil
			player.crouching = false
		end
		if player.peelout == nil
			player.peelout = false
		end
		if player.insta == nil
			player.insta = false
		end
		if player.instas == nil
			player.instas = false
		end
		if player.instar == nil
			player.instar = false
		end
		if player.rollafteruse == nil
			player.rollafteruse = false
		end
		if player.timeout == nil
			player.timeout = false
		end
		if player.rollangle == nil
			player.rollangle = false
		end
		if player.rollout == nil
			player.rollout = false
		end
		if player.loops == nil
			player.loops = false
		end
		if player.speedeffect == nil
			player.speedeffect = true
		end
		if player.peeloutanim == nil
			player.peeloutanim = false
		end
		if player.waterrun == nil
			player.waterrun = true
		end
		if player.stretch == nil
			player.stretch = false
		end
		if player.waterruneffect == nil
			player.waterruneffect = true
		end
		if player.push == nil
			player.push = false
		end
		if player.allclassics == nil
			player.allclassics = false
		end
		if player.speedchange
			player.speedchange = true
		end
		if player.movestack == nil
			player.movestack = false
		end
		if player.speedcap == nil
			player.speedcap = false
		end
		if player.uncurl == nil
			player.uncurl = true
		end
		if player.speedometer == nil
			player.speedometer = true
		end
		if player.jumptics == nil
			player.jumptics = 0
		end
		if player.spintics == nil
			player.spintics = 0
		end
		if (player.cmd.buttons & BT_JUMP)
			player.jumptics = $ + 1
		else
			player.jumptics = 0
		end
		if (player.cmd.buttons & BT_SPIN)
			player.spintics = $ + 1
		else
			player.spintics = 0
		end
	end
end)

COM_AddCommand("fallbackcam", function(player)
	if player.fallback
		player.fallback = false
		CONS_Printf(player, "Fallback cam is now off")
	else
		player.fallback = true
		CONS_Printf(player, "Fallback cam is now on")
	end
end)

COM_AddCommand("dropdashanim", function(player)
	if player.dodpanim
		player.dodpanim = false
		CONS_Printf(player, "No more dropdash animation")
	else
		player.dodpanim = true
		CONS_Printf(player, "Bad Dropdash animation for you")
	end
end) //End command

COM_AddCommand("speedometer", function(player)
	if player.speedometer
		player.speedometer = false
		CONS_Printf(player, "The Speedometer is now off")
	else
		player.speedometer = true
		CONS_Printf(player, "The Speedometer is now on")
	end
end)

// The Tables

rawset(_G, "MSStartup", function(player)
	if player.menu == nil
	or not player.menu
		player.menu = {
			selected = "continue",
			changing = false
		}
		CONS_Printf(player, "Classic Engine made by \x8Ekirb\x80")
		CONS_Printf(player, "We truly are \x88Livin the Dream\x80")
	end
end)

addHook("PlayerThink", MSStartup)